Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.management.modelmbean
Interface ModelMBeanNotificationBroadcaster

All Superinterfaces:
  NotificationBroadcaster, NotificationEmitter

All Known Subinterfaces:
  ModelMBean

All Known Implementing Classes:
  RequiredModelMBean

public interface ModelMBeanNotificationBroadcaster
extends NotificationEmitter

This interface must be implemented by the ModelMBeans. An implementation of this interface must be shipped with every JMX Agent.

Java resources wishing to be manageable instatiate the ModelMBean using the MBeanServer's createMBean method. The resource then sets the ModelMBeanInfo (with Descriptors) for the ModelMBean instance. The attributes and operations exposed via the ModelMBeanInfo for the ModelMBean are accessible from Mbeans, connectors/adapters like other MBeans. Through the ModelMBeanInfo Descriptors, values and methods in the managed application can be defined and mapped to attributes and operations of the ModelMBean. This mapping can be defined during development in an XML formatted file or dynamically and programmatically at runtime.

Every ModelMBean which is instantiated in the MBeanServer becomes manageable: its attributes and operations become remotely accessible through the connectors/adaptors connected to that MBeanServer. A Java object cannot be registered in the MBeanServer unless it is a JMX compliant MBean. By instantiating a ModelMBean, resources are guaranteed that the MBean is valid.

MBeanException and RuntimeOperatiosException must be thrown on every public method. This allows for wrappering exceptions from distributed communications (RMI, EJB, etc.). These exceptions do not have to be thrown by teh implementation except in the scenarios described in the specification and javadoc.

Author:
  Young Yang

Method Summary
`void` | `addAttributeChangeNotificationListener(NotificationListener listener, java.lang.String attributeName, java.lang.Object handback)` Registers an object which implements the NotificationListener interface as a listener for AttributeChangeNotifications.
`void` | `removeAttributeChangeNotificationListener(NotificationListener listener, java.lang.String attributeName)` Removes a listener for attributeChangeNotifications from the MBean.
`void` | `sendAttributeChangeNotification(Attribute oldValue, Attribute newValue)` Sends an attributeChangeNotification which contains the old value and new value for the attribute to the registered AttributeChangeNotification listeners on the ModelMBean.
`void` | `sendAttributeChangeNotification(AttributeChangeNotification notification)` Sends an attributeChangeNotification which is passed in to the registered attributeChangeNotification listeners on the ModelMBean.
`void` | `sendNotification(Notification notification)` Sends a Notification which is passed in to the registered Notification listeners on the ModelMBean as a jmx.modelmbean.general notification.
`void` | `sendNotification(java.lang.String message)` Sends a Notification which contains the text string that is passed in to the registered Notification listeners on the ModelMBean.

Methods inherited from interface javax.management.NotificationEmitter
`removeNotificationListener`

Methods inherited from interface javax.management.NotificationBroadcaster
`addNotificationListener, getNotificationInfo, removeNotificationListener`

Method Detail

### sendNotification

    public void sendNotification(Notification notification)
                          throws MBeanException,
                                 RuntimeOperationsException

  Sends a Notification which is passed in to the registered Notification listeners on the ModelMBean as a jmx.modelmbean.general notification.

  Parameters:
    `notification` - - The notification which is to be passed to the 'handleNotification' method of the listener object.
  Throws:
    `MBeanException` - The initializer of the object has thrown an exception.
    `RuntimeOperationsException` - Wraps an IllegalArgumentException: The Notification object passed in parameter is null or invalid.

### sendNotification

    public void sendNotification(java.lang.String message)
                          throws MBeanException,
                                 RuntimeOperationsException

  Sends a Notification which contains the text string that is passed in to the registered Notification listeners on the ModelMBean.

  Parameters:
    `message` - The text which is to be passed in the Notification to the 'handleNotification' method of the listener object. the constructed Notification will be: type "jmx.modelmbean.general" source this ModelMBean instance sequence 1
  Throws:
    `MBeanException` - The initializer of the object has thrown an exception.
    `RuntimeOperationsException` - Wraps an IllegalArgumentException: The Notification text string passed in parameter is null or invalid.

### sendAttributeChangeNotification

    public void sendAttributeChangeNotification(AttributeChangeNotification notification)
                                         throws MBeanException,
                                                RuntimeOperationsException

  Sends an attributeChangeNotification which is passed in to the registered attributeChangeNotification listeners on the ModelMBean.

  Parameters:
    `notification` - The notification which is to be passed to the 'handleNotification' method of the listener object.
  Throws:
    `MBeanException` - The initializer of the object has thrown an exception.
    `RuntimeOperationsException` - Wraps an IllegalArgumentException: The Notification object passed in parameter is null or invalid.

### sendAttributeChangeNotification

    public void sendAttributeChangeNotification(Attribute oldValue,
                                                Attribute newValue)
                                         throws MBeanException,
                                                RuntimeOperationsException

  Sends an attributeChangeNotification which contains the old value and new value for the attribute to the registered AttributeChangeNotification listeners on the ModelMBean.

  Parameters:
    `oldValue` - The origional value for the Attribute
    `newValue` - The current value for the Attribute

         The constructed attributeChangeNotification will be:
           type        "jmx.attribute.change"
           source      this ModelMBean instance
           sequence    1
           attributeName oldValue.getName()
           attributeType oldValue's class
           attributeOldValue oldValue.getValue()
           attributeNewValue newValue.getValue()

  Throws:
    `MBeanException` - to wrapper implementation exceptions
    `RuntimeOperationsException` - to wrapper IllegalArgumentExceptions.

### addAttributeChangeNotificationListener

    public void addAttributeChangeNotificationListener(NotificationListener listener,
                                                       java.lang.String attributeName,
                                                       java.lang.Object handback)
                                                throws MBeanException,
                                                       RuntimeOperationsException,
                                                       java.lang.IllegalArgumentException

  Registers an object which implements the NotificationListener interface as a listener for AttributeChangeNotifications. This object's 'handleNotification()' method will be invoked when any attributeChangeNotification is issued through or by the MBean. This does not include other Notifications. They must be registered for independently. An AttributeChangeNotification will be generated for this attributeName.

  Parameters:
    `listener` - The listener object which will handles notifications emitted by the registered MBean.
    `attributeName` - The name of the MBean attribute for which to receive change notifications. If null, then all attribute changes will cause an attributeChangeNotification to be issued.
    `handback` - The context to be sent to the listener with the notification when a notification is emitted.
  Throws:
    `java.lang.IllegalArgumentException` - Listener is null or attributeName is null.
    `MBeanException`
    `RuntimeOperationsException`

### removeAttributeChangeNotificationListener

    public void removeAttributeChangeNotificationListener(NotificationListener listener,
                                                          java.lang.String attributeName)
                                                   throws MBeanException,
                                                          RuntimeOperationsException,
                                                          ListenerNotFoundException

  Removes a listener for attributeChangeNotifications from the MBean.

  Parameters:
    `listener` - The listener name which was handling notifications emitted by the registered MBean. This method will remove all information related to this listener.
    `attributeName` - The attribute for which the listener no longer wants to receive attributeChangeNotifications.
  Throws:
    `ListenerNotFoundException` - The couple (listener,handback) is not registered in the MBean. The exception message contains either "listener", "handback" or the object name depending on which object cannot be found.
    `MBeanException`
    `RuntimeOperationsException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD